	cpu LMM
	.module main.c
	.area data(ram, con, rel)
L9:
	.byte 0,0,0,0,0,0
	.area data(ram, con, rel)
L10:
	.byte 0,0
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e USB_IN_Report _USB_IN_Report fV
	.dbsym s ReportRate_Countdown L10 i
	.dbsym s Last_Report L9 X
;           Send -> X+3
;     ReportMode -> X+2
;        FrameNr -> X+0
_USB_IN_Report::
	.dbline -1
	push X
	mov X,SP
	add SP,10
	.dbline 37
; //----------------------------------------------------------------------------
; // C main line for "Oak" Sensor
; // Version: 1.0, 2007/03/08 
; //
; ///----------------------------------------------------------------------------
; // Originally authored by Toradex AG. This work is now available under the terms and conditions
; // of the Creative Commons License 'Attribution CC BY', details of which can be found here:
; // http://creativecommons.org/licenses/by/3.0/
; ///----------------------------------------------------------------------------
; #define __DEBUG__
; 
; #include <m8c.h>        // part specific constants and macros
; #include <string.h>
; #include "PSoCAPI.h"    // PSoC API definitions for all User Modules
; #include "PSoCgpioInt.h"
; #include "USBsleeptimer.h"
; #include "feature.h"
; #include "parameters.h"
; #include "DigitalIO.h"
; #include "sensor.h"
; 
; //-----------------------------------------------------------------------------
; // global variables
; //-----------------------------------------------------------------------------
; extern BYTE SOF_Flag;	// Set in SOF_ISR
; 
; typedef char IN_Report[4];
; IN_Report	SensorValues;
; extern BYTE  USB_INTERFACE_0_IN_RPT_DATA[IN_REPORT_SIZE];
; 
; 
; //-----------------------------------------------------------------------------
; // State machine to send input reports to the host
; // call this function once every millisecond to maintain proper timings
; //-----------------------------------------------------------------------------
; void USB_IN_Report()
; {
	.dbline 45
; 	static tReport	Last_Report;
; 	static WORD		ReportRate_Countdown;
; 	BOOL			Send;
; 	WORD			FrameNr;
; 	eReportMode		ReportMode;
; 		
; 	// -- update counter for fixed report rate
; 	if (ReportRate_Countdown != 0)
	mov REG[0xd0],>L10
	cmp [L10],0
	jnz X1
	cmp [L10+1],0
	jz L11
X1:
	.dbline 46
; 		ReportRate_Countdown--;
	mov REG[0xd0],>L10
	dec [L10+1]
	sbb [L10],0
L11:
	.dbline 49
; 		
; 	// -- decide if IN report has to be sent, depending on the report mode
; 	Get_Param_8(PAR8_REPORTMODE, VOLATILE, (BYTE*)&ReportMode);
	mov REG[0xd0],>__r0
	mov [__r1],X
	add [__r1],2
	mov A,3
	push A
	mov A,[__r1]
	push A
	mov A,0
	push A
	push A
	xcall _Get_Param_8
	add SP,-4
	.dbline 50
; 	switch (ReportMode)
	mov A,[X+2]
	mov [X+5],A
	mov [X+4],0
	cmp [X+4],0
	jnz X2
	cmp [X+5],0
	jz L16
X2:
	cmp [X+4],0
	jnz X3
	cmp [X+5],1
	jz L17
X3:
	cmp [X+4],0
	jnz X4
	cmp [X+5],2
	jz L25
X4:
	xjmp L13
X0:
	.dbline 51
; 	{
L16:
	.dbline 53
; 		case AfterSampling:
; 			Send = NewSample;
	mov REG[0xd0],>_NewSample
	mov A,[_NewSample]
	mov [X+3],A
	.dbline 54
; 			break;
	xjmp L14
L17:
	.dbline 57
; 			
; 		case AfterChange:
; 			if (NewSample)
	mov REG[0xd0],>_NewSample
	cmp [_NewSample],0
	jz L18
	.dbline 58
; 				Send = memcmp( &Report.Ch1_LSB, &Last_Report.Ch1_LSB, IN_REPORT_SIZE-2 ) != 0;
	mov A,0
	push A
	mov A,4
	push A
	mov A,>L9+2
	push A
	mov A,<L9+2
	push A
	mov A,>_Report+2
	push A
	mov A,<_Report+2
	push A
	xcall _memcmp
	add SP,-6
	mov REG[0xd0],>__r0
	cmp [__r0],0
	jnz X5
	cmp [__r1],0
	jz L23
X5:
	mov [X+7],1
	mov [X+6],0
	xjmp L24
L23:
	mov [X+7],0
	mov [X+6],0
L24:
	mov REG[0xd0],>__r0
	mov A,[X+7]
	mov [X+3],A
	xjmp L14
L18:
	.dbline 60
; 			else
; 				Send = FALSE;
	mov [X+3],0
	.dbline 61
; 			break;
	xjmp L14
L25:
	.dbline 64
; 			
; 		case FixedRate:
; 			Send = (ReportRate_Countdown == 0);
	mov REG[0xd0],>L10
	cmp [L10],0
	jnz L27
	cmp [L10+1],0
	jnz L27
X6:
	mov [X+9],1
	mov [X+8],0
	xjmp L28
L27:
	mov [X+9],0
	mov [X+8],0
L28:
	mov REG[0xd0],>__r0
	mov A,[X+9]
	mov [X+3],A
	.dbline 65
; 			break;
L13:
L14:
	.dbline 69
; 	}
; 	
; 	// -- send report data
; 	if (Send)
	cmp [X+3],0
	jz L29
	.dbline 70
; 	{
L31:
	.dbline 73
; 		// readout absolute frame number --> transmit as timestamp
; 		do
; 			FrameNr = USB_SOF0 + 256*USB_SOF1;
	mov A,REG[0x49]
	mov REG[0xd0],>__r0
	mov [__r0],A
	mov [__r1],0
	mov A,REG[0x48]
	add A,[__r1]
	mov [__r1],A
	mov A,0
	adc A,[__r0]
	mov [__r0],A
	mov A,[__r1]
	mov [X+1],A
	mov A,[__r0]
	mov [X+0],A
L32:
	.dbline 74
	mov A,REG[0x49]
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov [__r0],0
	mov A,[X+0]
	mov [__r3],A
	mov A,0
	cmp A,[__r0]
	jnz L31
	mov A,[__r3]
	cmp A,[__r1]
	jnz L31
X7:
	.dbline 76
	mov A,>L10
	push A
	mov A,<L10
	push A
	mov A,0
	push A
	push A
	xcall _Get_Param_16
	add SP,-4
	.dbline 80
	mov A,[X+1]
	mov REG[0xd0],>_Report
	mov [_Report],A
	.dbline 81
	mov A,[X+0]
	mov [_Report+1],A
	.dbline 83
	push X
	mov A,1
	push A
	mov A,0
	push A
	mov A,6
	push A
	mov A,>_Report
	push A
	mov A,<_Report
	push A
	mov A,2
	push A
	xcall _USB_LoadInEP
	add SP,-6
	pop X
	.dbline 86
	mov A,0
	push A
	mov A,4
	push A
	mov A,>_Report+2
	push A
	mov A,<_Report+2
	push A
	mov A,>L9+2
	push A
	mov A,<L9+2
	push A
	xcall _memcpyLMM
	.dbline 88
	mov A,0
	push A
	mov A,6
	push A
	mov A,>_Report
	push A
	mov A,<_Report
	push A
	mov A,>_USB_INTERFACE_0_IN_RPT_DATA
	push A
	mov A,<_USB_INTERFACE_0_IN_RPT_DATA
	push A
	xcall _memcpyLMM
	add SP,-12
	.dbline 90
	mov REG[0xd0],>_NewSample
	mov [_NewSample],0
	.dbline 91
L29:
	.dbline -2
	.dbline 92
; 		while ((FrameNr / 256) != USB_SOF1);	// protect against overflow during readout
; 		
; 		Get_Param_16(PAR16_REPORTRATE_MS, VOLATILE, &ReportRate_Countdown);
; 
; 		// numeric values in reports are represented in little-endian format
; 		// with the least significant byte at the lowest address.			
; 		Report.Ch0_LSB = FrameNr & 0xFF;
; 		Report.Ch0_MSB = FrameNr / 0x100;
; 
; 		USB_LoadInEP(2, (BYTE*)&Report, IN_REPORT_SIZE, USB_TOGGLE);
; 		
; 		// update last transmitted sensor values (for detecting changes)
; 		memcpy(&Last_Report.Ch1_LSB, &Report.Ch1_LSB, IN_REPORT_SIZE-2);
; 		// copy data to IN report. Necessary to support GET_REPORT request
; 		memcpy(USB_INTERFACE_0_IN_RPT_DATA, &Report.Ch0_LSB, IN_REPORT_SIZE);
; 
; 		NewSample=FALSE;
; 	}
; }
L8:
	add SP,-10
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l Send 3 c
	.dbsym l ReportMode 2 c
	.dbsym l FrameNr 0 i
	.dbend
	.dbfunc e SuspendResume _SuspendResume fV
_SuspendResume::
	.dbline -1
	.dbline 100
; 
; //-----------------------------------------------------------------------------
; // 1) Suspend the CPU 
; // 2) wait for an interrupt to wake the CPU
; // 3) Resume to normal operation
; //-----------------------------------------------------------------------------
; void SuspendResume()
; {
	.dbline 101
; 	M8C_DisableGInt;
		and F, FEh

	.dbline 105
; 
; 	// -- prepare sleep
; 		// reset sensor to stop current measurement
; 	Sensor_Suspend();
	xcall _Sensor_Suspend
	.dbline 107
; 		// configure I/Os for minimum current consumption
; 	DigitalIO_Suspend();
	xcall _DigitalIO_Suspend
	.dbline 110
; 
; 		// activate "USB wakeup" interrupt
; 	M8C_EnableIntMask( INT_MSK2, INT_MSK2_WAKEUP );
	or REG[0xdf],-128
	.dbline 113
; 		// set sleep interval to 1sec, Osc-Freq to 3MHz, Bandgap OFF
; 	
; 	OSC_CR0 = OSC_CR0_CPU_3MHz | OSC_CR0_SLEEP_1Hz; 
	or F,0x10  ; iopage = 1
	mov REG[0xe0],24
	and F,0xEF ; iopage = 0
	.dbline 115
; 		// disable SleeptTimer interrupt
; 	M8C_DisableIntMask( INT_MSK0, INT_MSK0_SLEEP );
	and REG[0xe0],-65
	.dbline 118
; 
; 	// -- enter sleep
; 	M8C_Sleep
	or REG[0xff],8
		or  F, 01h

	.dbline 126
; 	M8C_EnableGInt;
; 	
; 	// -- zzzzz... zzz... zzzzzz...
; 	// -- ...
; 	// -- Rrrriiiiing...   Rrrrriiiiiing... Rrrriiiing...
; 	
; 	// enable SleeptTimer interrupt
; 	M8C_EnableIntMask( INT_MSK0, INT_MSK0_SLEEP );
	or REG[0xe0],64
	.dbline 132
; 		// if PLL mode was enabled (sync to external XTAL oscillator) it is recommended 
; 		// to wait 10ms after resume before switching to 12MHz
; 		// -> no need to do this, as we do not use PLL mode <- 
; 
; 		// set sleep interval to 1.95msec, Osc-Freq to 12MHz, Bandgap OFF
; 	OSC_CR0 = OSC_CR0_CPU_12MHz | OSC_CR0_SLEEP_512Hz; 
	or F,0x10  ; iopage = 1
	mov REG[0xe0],2
	and F,0xEF ; iopage = 0
	.dbline 135
; 	
; 		// restart sensor measurement
; 	Sensor_Resume();
	xcall _Sensor_Resume
	.dbline 137
; 		// restore I/O settings for proper operation
; 	DigitalIO_Resume();
	xcall _DigitalIO_Resume
	.dbline -2
	.dbline 138
; }
L37:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e main _main fV
_main::
	.dbline -1
	.dbline 146
; 
; //-----------------------------------------------------------------------------
; // void main(void)
; //
; //	main application for the USB attached SHT1x sensor
; //-----------------------------------------------------------------------------
; void main() 
; {
	.dbline 147
; 	USB_Start(0, USB_5V_OPERATION);
	push X
	mov X,3
	mov A,0
	xcall _USB_Start
	pop X
	.dbline 148
; 	M8C_EnableGInt;
		or  F, 01h

	.dbline 150
; 
; 	Sensor_Start();
	xcall _Sensor_Start
	.dbline 151
; 	SleepTimer_Start();
	xcall _SleepTimer_Start
	.dbline 152
; 	DigitalIO_Start();
	xcall _DigitalIO_Start
	.dbline 153
; 	Feature_Start();
	xcall _Feature_Start
	.dbline 156
; 
; 	#ifdef __DEBUG__
; 	Sensor_Debug();
	xcall _Sensor_Debug
	xjmp L40
L39:
	.dbline 161
; 	#endif
; 
; 	// wait for USB enumeration, enter low-power  mode if sensor is hot-plugged into suspended host
; 	while ( !USB_bGetConfiguration() )
; 		if (GotoSleep)
	mov REG[0xd0],>_GotoSleep
	cmp [_GotoSleep],0
	jz L42
	.dbline 162
; 			SuspendResume();
	xcall _SuspendResume
L42:
L40:
	.dbline 160
	push X
	xcall _USB_bGetConfiguration
	mov REG[0xd0],>__r0
	pop X
	cmp A,0
	jz L39
	.dbline 163
; 	USB_INT_REG |= USB_INT_SOF_MASK;
	or REG[0xdf],2
	xjmp L45
L44:
	.dbline 166
; 
; 	while(1)
; 	{
	.dbline 167
; 		if (SOF_Flag) 
	mov REG[0xd0],>_SOF_Flag
	cmp [_SOF_Flag],0
	jz L47
	.dbline 168
; 		{	// get here once every millisecond, as long as USB is active
	.dbline 169
; 			SOF_Flag = 0;
	mov [_SOF_Flag],0
	.dbline 171
; 
; 			Sensor_FSM_Measure();
	xcall _Sensor_FSM_Measure
	.dbline 173
; 	
; 			USB_IN_Report();
	xcall _USB_IN_Report
	.dbline 174
; 			FSM_LEDmode();
	xcall _FSM_LEDmode
	.dbline 175
; 		} 
L47:
	.dbline 178
; 			
; 		// the following code is executed independent of the millisecond tick rate.
; 		if (GotoSleep)
	mov REG[0xd0],>_GotoSleep
	cmp [_GotoSleep],0
	jz L49
	.dbline 179
; 			SuspendResume();
	xcall _SuspendResume
L49:
	.dbline 181
	xcall _ProcessFeatureReports
	.dbline 182
L45:
	.dbline 165
	xjmp L44
X8:
	.dbline -2
	.dbline 183
; 		
; 		ProcessFeatureReports();
; 	} 
; }
L38:
	.dbline 0 ; func end
	jmp .
	.dbend
	.area data(ram, con, rel)
	.dbfile ./main.c
_SensorValues::
	.byte 0,0,0,0
	.dbsym e SensorValues _SensorValues A[4:4]c
